/* Copyright 2009 Fog Creek Software, Inc. */

using System;
using System.Collections.Generic;
using System.Text;
using System.Web;

/* FogBugz namespaces-- make sure you add the neccesary assembly references to
 * the following DLL files contained in C:\Program Files\FogBugz\Website\bin\ 
 * FogBugz.dll, FogCreek.Plugins.dll, FogCreek.Plugins.InterfaceEvents.dll     */
using FogCreek.FogBugz.Plugins;
using FogCreek.FogBugz.Plugins.Api;
using FogCreek.FogBugz.Plugins.Entity;
using FogCreek.FogBugz.Plugins.Interfaces;
using FogCreek.FogBugz;
using FogCreek.FogBugz.UI.Dialog;

namespace IPluginFilterDisplay_Example
{
    /* Class Declaration: Inherit from Plugin, implement IPluginFilterDisplay */
    public class IPluginFilterDisplay_Example : Plugin, IPluginFilterDisplay
    {
        /* Constructor: We'll just initialize the inherited Plugin class, which 
         * takes the passed instance of CPluginApi and sets its "api" member variable. */
        public IPluginFilterDisplay_Example(CPluginApi api)
            : base(api)
        {
        }

        #region IPluginFilterDisplay Members

        public CDialogItem[] FilterDisplayEdit(CFilter filter)
        {
            /* display a dialog item for the Wiki configuration page with content,
             * label and instructions html provided */
            return new CDialogItem[] { new CDialogItem(
                @"<input type=""checkbox"" name=""unused"" /> Created by FilterDisplayEdit
                method.",
                "Plugin Example", "Instructions are shown here.") };
        }

        public string[] FilterDisplayListFields(CFilter filter)
        {
            /* Display a field containing the sComputer value for the Cfilter object
             * on the Manage Saved Filters page */
            return new string[] { HttpUtility.HtmlEncode(filter.sComputer) };
        }

        public string[] FilterDisplayListHeaders()
        {
            /* Display a label for our new field on the Manage Saved Filters page */
            return new string[] { "Computer field" };
        }

        #endregion
    }
}